From f96220d9466d6c0f28d39d7d0cd03c82e62da079 Mon Sep 17 00:00:00 2001
From: Shveta Malik <shveta.malik@gmail.com>
Date: Mon, 22 May 2023 08:54:50 +0530
Subject: [PATCH 8/8] ObjTree Removal for multiple commands.

1. create table
2. alter table
3. drop table
4. create sequence
5. alter sequence
6. alter object owner to
7. alter object set schema
8. alter object rename
---
 src/backend/commands/ddldeparse.c             | 3601 ++++++++---------
 src/backend/replication/logical/ddltrigger.c  |    5 +-
 src/include/tcop/ddldeparse.h                 |    4 +-
 .../expected/alter_table.out                  |  278 +-
 .../expected/constraints.out                  |  284 +-
 .../expected/create_index.out                 |    4 +-
 .../expected/create_rule.out                  |   16 +-
 .../expected/create_table.out                 |  300 +-
 .../test_ddl_deparse_regress.c                |    6 +-
 9 files changed, 2239 insertions(+), 2259 deletions(-)

diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 5878d7e465..7165ead751 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -67,53 +67,6 @@
 /* Estimated length of the generated jsonb string */
 #define JSONB_ESTIMATED_LEN 128
 
-/*
- * Before they are turned into JSONB representation, each command is
- * represented as an object tree, using the structs below.
- */
-typedef enum
-{
-	ObjTypeNull,
-	ObjTypeBool,
-	ObjTypeString,
-	ObjTypeArray,
-	ObjTypeInteger,
-	ObjTypeObject
-} ObjType;
-
-/*
- * Represent the command as an object tree.
- */
-typedef struct ObjTree
-{
-	slist_head	params;			/* Object tree parameters */
-	int			numParams;		/* Number of parameters in the object tree */
-	StringInfo	fmtinfo;		/* Format string of the ObjTree */
-	bool		present;		/* Indicates if boolean value should be stored */
-} ObjTree;
-
-/*
- * An element of an object tree (ObjTree).
- */
-typedef struct ObjElem
-{
-	char	   *name;			/* Name of object element */
-	ObjType		objtype;		/* Object type */
-
-	union
-	{
-		bool		boolean;
-		char	   *string;
-		int64		integer;
-		float8		flt;
-		ObjTree    *object;
-		List	   *array;
-	}			value;			/* Store the object value based on the object
-								 * type */
-	slist_node	node;			/* Used in converting back to ObjElem
-								 * structure */
-} ObjElem;
-
 /*
  * Reduce some unnecessary strings from the output json when verbose
  * and "present" member is false. This means these strings won't be merged into
@@ -121,50 +74,11 @@ typedef struct ObjElem
  */
 bool		verbose = true;
 
-static void append_format_string(ObjTree *tree, char *sub_fmt);
-static void append_array_object(ObjTree *tree, char *sub_fmt, List *array);
-static void append_bool_object(ObjTree *tree, char *sub_fmt, bool value);
-static void append_object_object(ObjTree *tree, char *sub_fmt, ObjTree *value);
-static char *append_object_to_format_string(ObjTree *tree, char *sub_fmt);
-static void append_premade_object(ObjTree *tree, ObjElem *elem);
-static void append_string_object(ObjTree *tree, char *sub_fmt, char *object_name,
-								 char *value);
-static ObjElem *new_object(ObjType type, char *name);
-static ObjTree *new_objtree_for_qualname_id(Oid classId, Oid objectId);
-static ObjElem *new_object_object(ObjTree *value);
-static ObjTree *new_objtree_VA(char *fmt, int numobjs, ...);
-static JsonbValue *objtree_to_jsonb_rec(ObjTree *tree, JsonbParseState *state, char *owner);
-static char *RelationGetColumnDefault(Relation rel, AttrNumber attno,
-									  List *dpcontext, Node **expr);
-
-static ObjTree *deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
-								  ColumnDef *coldef, bool is_alter, Node **expr);
-static ObjTree *deparse_ColumnIdentity(Oid seqrelid, char identity, bool alter_table);
-static ObjTree *deparse_ColumnSetOptions(AlterTableCmd *subcmd);
-
-static ObjTree *deparse_DefElem(DefElem *elem, bool is_reset);
-static ObjTree *deparse_OnCommitClause(OnCommitAction option);
-static ObjTree *deparse_RelSetOptions(AlterTableCmd *subcmd);
-
-static inline ObjElem *deparse_Seq_Cache(Form_pg_sequence seqdata, bool alter_table);
-static inline ObjElem *deparse_Seq_Cycle(Form_pg_sequence seqdata, bool alter_table);
-static inline ObjElem *deparse_Seq_IncrementBy(Form_pg_sequence seqdata, bool alter_table);
-static inline ObjElem *deparse_Seq_Minvalue(Form_pg_sequence seqdata, bool alter_table);
-static inline ObjElem *deparse_Seq_Maxvalue(Form_pg_sequence seqdata, bool alter_table);
-static inline ObjElem *deparse_Seq_Restart(int64 last_value);
-static inline ObjElem *deparse_Seq_Startwith(Form_pg_sequence seqdata, bool alter_table);
-static inline ObjElem *deparse_Seq_As(Form_pg_sequence seqdata);
-
-static List *deparse_InhRelations(Oid objectId);
-static List *deparse_TableElements(Relation relation, List *tableElements, List *dpcontext,
-								   bool typed, bool composite);
-static void mark_function_volatile(ddl_deparse_context *context, Node *expr);
-
 /*
  * Mark the func_volatile flag for an expression in the command.
  */
 static void
-mark_function_volatile(ddl_deparse_context *context, Node *expr)
+mark_function_volatile(ddl_deparse_context * context, Node *expr)
 {
 	if (context->func_volatile == PROVOLATILE_VOLATILE)
 		return;
@@ -181,276 +95,266 @@ mark_function_volatile(ddl_deparse_context *context, Node *expr)
 }
 
 /*
- * Append present as false to a tree.
- * If sub_fmt is passed and verbose mode is ON,
- * append sub_fmt as well to tree.
- *
- * Example:
- * in non-verbose mode, element will be like:
- * "collation": {"fmt": "COLLATE", "present": false}
- * in verbose mode:
- * "collation": {"fmt": "COLLATE %{name}D", "present": false}
+ * Return the string representation of the given RELPERSISTENCE value.
  */
-static void
-append_not_present(ObjTree *tree, char *sub_fmt)
+static char *
+get_persistence_str(char persistence)
 {
-	if (verbose && sub_fmt)
+	switch (persistence)
 	{
-		append_format_string(tree, sub_fmt);
+		case RELPERSISTENCE_TEMP:
+			return "TEMPORARY";
+		case RELPERSISTENCE_UNLOGGED:
+			return "UNLOGGED";
+		case RELPERSISTENCE_PERMANENT:
+			return "";
+		default:
+			elog(ERROR, "unexpected persistence marking %c", persistence);
+			return "";			/* make compiler happy */
 	}
-
-	append_bool_object(tree, "present", false);
 }
 
 /*
- * Append an array parameter to a tree.
+ * Obtain the deparsed default value for the given column of the given table.
+ *
+ * Caller must have set a correct deparse context and must ensure that the
+ * passed attribute has a default value.
  */
-static void
-append_array_object(ObjTree *tree, char *sub_fmt, List *array)
+static char *
+RelationGetColumnDefault(Relation rel, AttrNumber attno, List *dpcontext,
+						 Node **expr)
 {
-	ObjElem    *param;
-	char	   *object_name;
-
-	Assert(sub_fmt);
-
-	if (list_length(array) == 0)
-		return;
-
-	if (!verbose)
-	{
-		ListCell   *lc;
-
-		/* Remove elements where present flag is false */
-		foreach(lc, array)
-		{
-			ObjElem    *elem = (ObjElem *) lfirst(lc);
-
-			Assert(elem->objtype == ObjTypeObject ||
-				   elem->objtype == ObjTypeString);
-
-			if (!elem->value.object->present &&
-				elem->objtype == ObjTypeObject)
-				array = foreach_delete_current(array, lc);
-		}
+	Node	   *defval;
+	char	   *defstr;
 
-	}
+	defval = build_column_default(rel, attno);
+	Assert(defval != NULL);
 
-	/* Check for empty list after removing elements */
-	if (list_length(array) == 0)
-		return;
+	defstr = deparse_expression(defval, dpcontext, false, false);
 
-	object_name = append_object_to_format_string(tree, sub_fmt);
+	/* Collect the expression for later replication safety checks */
+	if (expr)
+		*expr = defval;
 
-	param = new_object(ObjTypeArray, object_name);
-	param->value.array = array;
-	append_premade_object(tree, param);
+	return defstr;
 }
 
 /*
- * Append a boolean parameter to a tree.
+ * Obtain the deparsed partition bound expression for the given table.
  */
-static void
-append_bool_object(ObjTree *tree, char *sub_fmt, bool value)
+static char *
+RelationGetPartitionBound(Oid relid)
 {
-	ObjElem    *param;
-	char	   *object_name = sub_fmt;
+	Datum		deparsed;
+	Datum		boundDatum;
+	bool		isnull;
+	HeapTuple	tuple;
 
-	Assert(sub_fmt);
+	tuple = SearchSysCache1(RELOID, relid);
+	if (!HeapTupleIsValid(tuple))
+		elog(ERROR, "cache lookup failed for relation with OID %u", relid);
 
-	/*
-	 * Check if the format string is 'present' and if yes, store the boolean
-	 * value
-	 */
-	if (strcmp(sub_fmt, "present") == 0)
-		tree->present = value;
-	else
-		object_name = append_object_to_format_string(tree, sub_fmt);
+	boundDatum = SysCacheGetAttr(RELOID, tuple,
+								 Anum_pg_class_relpartbound,
+								 &isnull);
+
+	deparsed = DirectFunctionCall2(pg_get_expr,
+								   CStringGetTextDatum(TextDatumGetCString(boundDatum)),
+								   relid);
+
+	ReleaseSysCache(tuple);
 
-	param = new_object(ObjTypeBool, object_name);
-	param->value.boolean = value;
-	append_premade_object(tree, param);
+	return TextDatumGetCString(deparsed);
 }
 
 /*
- * Append the input format string to the ObjTree.
+ * Insert JsonbValue key to the output parse state.
  */
 static void
-append_format_string(ObjTree *tree, char *sub_fmt)
+insert_jsonb_key(JsonbParseState *state, char *name)
 {
-	int			len;
-	char	   *fmt;
-
-	Assert(sub_fmt);
-
-	if (tree->fmtinfo == NULL)
-		return;
-
-	fmt = tree->fmtinfo->data;
-	len = tree->fmtinfo->len;
-
-	/* Add a separator if necessary */
-	if (len > 0 && fmt[len - 1] != ' ')
-		appendStringInfoSpaces(tree->fmtinfo, 1);
+	JsonbValue	key;
 
-	appendStringInfoString(tree->fmtinfo, sub_fmt);
+	/* Push the key */
+	key.type = jbvString;
+	key.val.string.val = name;
+	key.val.string.len = strlen(name);
+	pushJsonbValue(&state, WJB_KEY, &key);
 }
 
 /*
- * Append an object parameter to a tree.
+ * Insert the format string to the output parse state.
  */
 static void
-append_object_object(ObjTree *tree, char *sub_fmt, ObjTree *value)
+fmt_to_jsonb_element(JsonbParseState *state, char *fmtStr)
 {
-	ObjElem    *param;
-	char	   *object_name;
-
-	Assert(sub_fmt);
+	JsonbValue	val;
 
-	if (!verbose && !value->present)
-		return;
+	Assert(fmtStr);
 
-	object_name = append_object_to_format_string(tree, sub_fmt);
+	/* Push the key first */
+	insert_jsonb_key(state, "fmt");
 
-	param = new_object(ObjTypeObject, object_name);
-	param->value.object = value;
-	append_premade_object(tree, param);
+	/* Push the value now */
+	val.type = jbvString;
+	val.val.string.val = pstrdup(fmtStr);
+	val.val.string.len = strlen(fmtStr);
+	pushJsonbValue(&state, WJB_VALUE, &val);
 }
 
 /*
- * Return the object name which is extracted from the input "*%{name[:.]}*"
- * style string. And append the input format string to the ObjTree.
+ * Append new jsonb key:value pair to the output parse state -- varargs version.
+ *
+ * The "fmt" argument is used to append as a "fmt" element in current object.
+ * The "skipObject" argument indicates if we want to skip object creation
+ * considering it will be taken care by the caller.
+ * The "numobjs" argument indicates the number of extra elements to append;
+ * for each one, a name (string), type (from the jbvType enum) and value must
+ * be supplied.  The value must match the type given; for instance, jbvBool
+ * requires an * bool, jbvString requires a char * and so no,
+ * Each element type  must match the conversion specifier given in the format
+ * string, as described in ddl_deparse_expand_command.
+ *
+ * Note we don't have the luxury of sprintf-like compiler warnings for
+ * malformed argument lists.
  */
-static char *
-append_object_to_format_string(ObjTree *tree, char *sub_fmt)
+static JsonbValue *
+new_jsonb_VA(JsonbParseState *state, char *fmt, bool skipObject, int numobjs,...)
 {
-	StringInfoData object_name;
-	const char *end_ptr, *start_ptr;
+	va_list		args;
+	int			i;
+	JsonbValue	val;
+	JsonbValue *value = NULL;
 
-	Assert(tree->fmtinfo);
+	/* Set up the toplevel object if not instructed otherwise */
+	if (!skipObject)
+		pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+	/* Set up the "fmt" */
+	if (fmt)
+		fmt_to_jsonb_element(state, fmt);
 
-	initStringInfo(&object_name);
 
-	start_ptr = strchr(sub_fmt, '{');
-	end_ptr = strchr(sub_fmt, ':');
-	if (end_ptr == NULL)
-		end_ptr = strchr(sub_fmt, '}');
+	/* And process the given varargs */
+	va_start(args, numobjs);
 
-	if (start_ptr != NULL && end_ptr != NULL)
+	for (i = 0; i < numobjs; i++)
 	{
-		appendBinaryStringInfo(&object_name, start_ptr + 1,
-								end_ptr - start_ptr - 1);
-	}
+		char	   *name;
+		enum jbvType type;
 
-	if (object_name.len == 0)
-		elog(ERROR, "object name not found");
+		name = va_arg(args, char *);
+		type = va_arg(args, enum jbvType);
 
-	append_format_string(tree, sub_fmt);
+		/* Push the key first */
+		insert_jsonb_key(state, name);
 
-	return object_name.data;
-}
+		/*
+		 * For all param types other than jbvNull, there must be a value in
+		 * the varargs. Fetch it and add the fully formed subobject into the
+		 * main object.
+		 */
+		switch (type)
+		{
+			case jbvNull:
+				/* Null params don't have a value (obviously) */
+				val.type = jbvNull;
+				pushJsonbValue(&state, WJB_VALUE, &val);
+				break;
 
-/*
- * Append a preallocated parameter to a tree.
- */
-static inline void
-append_premade_object(ObjTree *tree, ObjElem *elem)
-{
-	slist_push_head(&tree->params, &elem->node);
-	tree->numParams++;
-}
+			case jbvBool:
+				/* Push the bool value */
+				val.type = jbvBool;
+				val.val.boolean = va_arg(args, int);
+				pushJsonbValue(&state, WJB_VALUE, &val);
+				break;
 
-/*
- * Append a string parameter to a tree.
- */
-static void
-append_string_object(ObjTree *tree, char *sub_fmt, char *object_name,
-					 char *value)
-{
-	ObjElem    *param;
+			case jbvString:
+				/* Push the string value */
+				val.type = jbvString;
+				val.val.string.val = pstrdup(va_arg(args, char *));
+				val.val.string.len = strlen(val.val.string.val);
+				pushJsonbValue(&state, WJB_VALUE, &val);
+				break;
 
-	Assert(sub_fmt);
+			case jbvNumeric:
+				/* Push the numeric value */
+				val.type = jbvNumeric;
+				val.val.numeric = (Numeric) DatumGetNumeric(DirectFunctionCall1(int8_numeric,
+																				va_arg(args, int)));
 
-	if (!verbose && (value == NULL || value[0] == '\0'))
-		return;
+				pushJsonbValue(&state, WJB_VALUE, &val);
+				break;
 
-	append_format_string(tree, sub_fmt);
-	param = new_object(ObjTypeString, object_name);
-	param->value.string = value;
-	append_premade_object(tree, param);
-}
+			default:
+				elog(ERROR, "unrecognized jbvType %d", type);
+		}
 
-/*
- * Return the string representation of the given RELPERSISTENCE value.
- */
-static char *
-get_persistence_str(char persistence)
-{
-	switch (persistence)
-	{
-		case RELPERSISTENCE_TEMP:
-			return "TEMPORARY";
-		case RELPERSISTENCE_UNLOGGED:
-			return "UNLOGGED";
-		case RELPERSISTENCE_PERMANENT:
-			return "";
-		default:
-			elog(ERROR, "unexpected persistence marking %c", persistence);
-			return "";			/* make compiler happy */
 	}
+
+	va_end(args);
+
+	if (!skipObject)
+		value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
+	return value;
 }
 
 /*
- * Allocate a new parameter.
+ * Insert new object with present:false as key-value pair
+ * to the output parse state.
  */
-static ObjElem *
-new_object(ObjType type, char *name)
+static void
+insert_not_present_obj(JsonbParseState *state, char *fmt)
 {
-	ObjElem    *param;
 
-	param = palloc0(sizeof(ObjElem));
-	param->name = name;
-	param->objtype = type;
-
-	return param;
+	new_jsonb_VA(state, fmt, false, 1,
+				 "present", jbvBool, false);
 }
 
 /*
- * Allocate a new object parameter.
+ * Process the role string into the output parse state.
  */
-static ObjElem *
-new_object_object(ObjTree *value)
+static void
+role_to_jsonb_element(JsonbParseState *state, char *owner)
 {
-	ObjElem    *param;
-
-	param = new_object(ObjTypeObject, NULL);
-	param->value.object = value;
+	if (owner == NULL)
+		return;
 
-	return param;
+	new_jsonb_VA(state, NULL, true, 1,
+				 "myowner", jbvString, owner);
 }
 
 /*
- * Allocate a new object tree to store parameter values.
+ * A helper routine to insert jsonb for coltyp to the output parse state.
  */
-static ObjTree *
-new_objtree(char *fmt)
+static void
+new_jsonb_for_type(JsonbParseState *state, Oid typeId, int32 typmod)
 {
-	ObjTree    *objtree;
+	Oid			typnspid;
+	char	   *type_nsp;
+	char	   *type_name = NULL;
+	char	   *typmodstr;
+	bool		type_array;
 
-	objtree = palloc0(sizeof(ObjTree));
-	objtree->present = true;
-	slist_init(&objtree->params);
+	format_type_detailed(typeId, typmod,
+						 &typnspid, &type_name, &typmodstr, &type_array);
 
-	if (fmt)
-	{
-		objtree->fmtinfo = makeStringInfo();
-		appendStringInfoString(objtree->fmtinfo, fmt);
-	}
+	if (OidIsValid(typnspid))
+		type_nsp = get_namespace_name_or_temp(typnspid);
+	else
+		type_nsp = pstrdup("");
+
+	new_jsonb_VA(state, NULL, false, 4,
+				 "schemaname", jbvString, type_nsp,
+				 "typename", jbvString, type_name,
+				 "typmod", jbvString, typmodstr,
+				 "typarray", jbvBool, type_array);
 
-	return objtree;
 }
 
 /*
- * A helper routine to set up %{}D and %{}O elements.
+ * A helper routine to set up name: schemaname, objname
  *
  * Elements "schema_name" and "obj_name" are set.  If the namespace OID
  * corresponds to a temp schema, that's set to "pg_temp".
@@ -459,10 +363,9 @@ new_objtree(char *fmt)
  * be quoted as an identifier or not, which is not something that this routine
  * concerns itself with; that will be up to the expand function.
  */
-static ObjTree *
-new_objtree_for_qualname(Oid nspid, char *name)
+static void
+new_jsonb_for_qualname(JsonbParseState *state, Oid nspid, char *objName, char *keyName, bool skipObject)
 {
-	ObjTree    *qualified;
 	char	   *namespace;
 
 	if (isAnyTempNamespace(nspid))
@@ -470,21 +373,22 @@ new_objtree_for_qualname(Oid nspid, char *name)
 	else
 		namespace = get_namespace_name(nspid);
 
-	qualified = new_objtree_VA(NULL, 2,
-							   "schemaname", ObjTypeString, namespace,
-							   "objname", ObjTypeString, pstrdup(name));
+	/* Push the key first */
+	if (keyName)
+		insert_jsonb_key(state, keyName);
 
-	return qualified;
+	new_jsonb_VA(state, NULL, skipObject, 2,
+				 "schemaname", jbvString, namespace,
+				 "objname", jbvString, objName);
 }
 
 /*
- * A helper routine to set up %{}D and %{}O elements, with the object specified
- * by classId/objId.
+ * A helper routine to set up name: 'schemaname, objname' where the object is
+ * specified by classId and objId.
  */
-static ObjTree *
-new_objtree_for_qualname_id(Oid classId, Oid objectId)
+static void
+new_jsonb_for_qualname_id(JsonbParseState *state, Oid classId, Oid objectId, char *keyName, bool skipObject)
 {
-	ObjTree    *qualified;
 	Relation	catalog;
 	HeapTuple	catobj;
 	Datum		obj_nsp;
